SystemOrganization addCategory: #VMP!

PGConnection subclass: #DatabaseAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!DatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:45'!
connect

 ^ true! !

!DatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:45'!
connectionFailed

 ^ false! !

!DatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:45'!
disconnect

 ^ true! !

DatabaseAccess subclass: #RelationalDatabaseAccess
	instanceVariableNames: 'connection'
	classVariableNames: 'connection2'
	poolDictionaries: ''
	category: 'VMP'!

!RelationalDatabaseAccess class methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 20:23'!
dbconnection
	connection2 isNil
		ifTrue: [self setupConnection].
	^ connection2! !

!RelationalDatabaseAccess class methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 19:04'!
setupConnection
Transcript show: 'creating connection'; cr.
 self connection2: (PGConnection new
  connectionArgs: self connectionArguments;
  startup;
  yourself).! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
addTask: aTask toUser: aUser

 self class writeMutex critical: [
  self connection execute:
   'insert into sttask
    (taskName, taskDescription, completed, deadline, stuser)
   values
    (''', aTask taskName, ''',
    ''', aTask taskDescription, ''',
    ''', aTask completed, ''',
    ''', aTask deadline, ''',
    ''', aUser email, ''')'.
  aTask id: self lastInsertedTaskId].! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
addUser: aUser

 self connection execute:
  'insert into stuser (userName, password, email)
  values
   (''', aUser userName,''',
   ''', aUser password,''',
   ''', aUser email,''');'.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
connect
"Transcript show: 'criando a conecao'; cr."
Transcript show: self connectionArguments; cr.
 self connection: (PGConnection new
  connectionArgs: self connectionArguments;
  startup;
  yourself).! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
connection
	^ connection! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
connection: value
	connection := value! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
connectionArguments
^ PGConnectionArgs
  hostname: self hostname
  portno: self port
  databaseName: self databaseName
  userName: self userName
  password: self password.
  ! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
connectionFailed

 ^ self connection isNil or: [self connection isConnected not]! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 20:16'!
createConnection
"Transcript show: 'criando a conecao'; cr."
Transcript show: self connectionArguments; cr.
 self connection2: (PGConnection new
  connectionArgs: self connectionArguments;
  startup;
  yourself).! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
createTables

 self
  createUserTable;
  createTaskTable.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
createTaskTable

 self connection execute:
  'CREATE TABLE sttask (
  id serial PRIMARY KEY,
  taskName varchar(50) NOT NULL,
  taskDescription varchar(200),
  completed boolean NOT NULL,
  deadline date NOT NULL,
  stuser varchar(50) references stuser(email) NOT NULL);'.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
createUserTable

 self connection execute:
  'CREATE TABLE stuser (
  userName varchar(50) NOT NULL,
  password varchar(50) NOT NULL,
  email varchar(50) NOT NULL PRIMARY KEY);'.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
databaseName

 ^ 'squeak'! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
disconnect

 (self connection notNil and: [self connection isConnected])
  ifTrue: [self connection terminate].! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
findUserByEmail: aString 

 ^ StUser find: [ :each | each email = aString]! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
hostname

 ^ 'localhost'! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
initialize
 super initialize.
 Transcript show: 'chamado para connect'; cr.
 self connect.

! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
lastInsertedTaskId

 | result |
 result := self connection execute:
  'select currval(pg_get_serial_sequence(''sttask', '''id''));'.
 ^ result errorResponse
  ifNil: [result resultSets first dataRows first at: 1]! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
password

 ^ 'squeak'! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
port

 ^ 5432! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
retrieveUserByEmail: aString

 | resultSet |
 resultSet := self connection execute:
  'select * from stuser where email=''', aString, ''';'.
 ^ StUser newFromResultSet: resultSet! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
setup

 self new
  connect;
  createTables;
  disconnect.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
updateTask: aTask

 | user | 
 user := StUser find: [ :each | each tasks includes: aTask]. 
 user save.! !

!RelationalDatabaseAccess methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 11:42'!
userName

 ^ 'squeak'! !

WAComponent subclass: #VolunteerListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!VolunteerListView methodsFor: 'rendering' stamp: 'eve 11/5/2012 18:35'!
addContact
    | name emailAddress |
    name := self request: 'Name'.
    emailAddress := self request: 'Email address'.
    Contact addContact: (Contact name: name emailAddress: emailAddress)! !

!VolunteerListView methodsFor: 'rendering' stamp: 'eve 11/5/2012 18:35'!
editContact: aContact
    | view |
    view := ContactView new.
    view contact: aContact.
    self show: view onAnswer: [ :answer |
        self inform: 'Thanks for editing  ' , aContact name ]! !

!VolunteerListView methodsFor: 'rendering' stamp: 'eve 11/5/2012 18:35'!
removeContact: aContact
    (self confirm: 'Are you sure that you want to remove this contact?')
        ifTrue: [ Contact removeContact: aContact ]! !

!VolunteerListView methodsFor: 'rendering' stamp: 'eve 11/5/2012 18:35'!
renderContact: aContact on: html
	html text: aContact name.
	html space.
	html anchor
		url: 'mailto:' , aContact emailAddress;
		with: aContact emailAddress.
	html text: ' ('.
	html anchor
		callback: [ self editContact: aContact ];
		with: 'edit'.	" <-- added "
	html space.
	html anchor
		callback: [ self removeContact: aContact ];
		with: 'remove'.
	html text: ')'! !

!VolunteerListView methodsFor: 'rendering' stamp: 'eve 11/5/2012 18:45'!
renderContentOn: html
    html anchor
        callback: [ self addContact ];
        with: 'Add Volunteer'.
    html unorderedList: [
        Volunteer contacts do: [ :contact |
            html listItem: [ self renderContact: contact on: html ] ] ]! !

TestCase subclass: #MySetTest
	instanceVariableNames: 'full empty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!MySetTest methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 22:17'!
setUp
	ProjectVolunteer createSampleDatabase.
	Skill createSampleDatabase.
	Volunteer createSampleDatabase! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testAddCoordinatorToProject
	| volunteer t1 t2 t3 task projectId |
	Transcript cr.
	Transcript show: '** test testAddCoordinatorToProject'.
	Transcript cr.
	volunteer := 1.
	projectId := 1.
	t1 := ProjectVolunteer getProject: projectId.
	t2 := Volunteer volunteers at: volunteer.
	t1 addCoordinatorToProject: t2.
	t3 := t1 coordinators includes: t2.
	ProjectVolunteer updateProject: t1.
	self assert: t3! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testAddSkillVolunteer
	| volunteer t1 t2 t3 task t4 |
	Transcript cr.
	Transcript show: '** test testAddSkillVolunteer'.
	Transcript cr.
	volunteer := 1.
	task := 1.
	t1 := Volunteer volunteers at: volunteer.
	t2 := Skill getSkill: task.
	Transcript show: t1 skills size;
		 cr.
	t1 addSkillToVolunteer: t2.
	t3 := t1 skills includes: t2.
	Transcript show: t1 skills size;
		 cr.
	Volunteer updateVolunteer: t1.
	self assert: t3! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testAddTask
	| task1 isTrue |
	task1 := Task new.
	task1 taskId: 4.
	task1 name: 'Task Test'.
	task1 description: 'Description Test'.
	Task addTask: task1.
	isTrue := Task tasks includes: task1.
	self assert: isTrue! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testCreateProject
	| t1 t2 |
	Transcript cr.
	Transcript show: '** test testCreateVolunteer'.
	Transcript cr.
	t1 := ProjectVolunteer new.
	t1 projectId: 5.
	t1 name: 'project Test'.
	ProjectVolunteer insertProject: t1.
	t2 := ProjectVolunteer projects includes: t1.
	self assert: t2! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testCreateSkill
	| t1 t2 |
	Transcript cr.
	Transcript show: '** test testCreateSkill'.
	Transcript cr.
	t1 := Skill new.
	t1 skillId: 4.
	t1 name: 'english language'.
	Skill insertSkill: t1.
	t2 := Skill skills includes: t1.
	self assert: t2! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testCreateVolunteer
	| t1 t2 |
	Transcript cr.
	Transcript show: '** test testCreateVolunteer'.
	Transcript cr.
	t1 := Volunteer new.
	t1 volunteerId: 5.
	t1 name: 'User Test'.
	Volunteer insertVolunteer: t1.
	t2 := Volunteer volunteers includes: t1.
	self assert: t2! !

!MySetTest methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 21:53'!
testDeleteVolunteer
	| t1 t2 t3 st id user idToRemove |
	Transcript cr.
	Transcript show: '** test testDeleteVolunteer'.
	Transcript cr.
	idToRemove := 1.
	user := 1.
	t1 := Volunteer volunteers at: idToRemove.
	Volunteer deleteVolunteer: idToRemove idCoordinator: user.
	t2 := Volunteer volunteers at: idToRemove.
	st := t2 status.
	t3 := st = 'disable'.
	self assert: t3! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testRejectVolunteerToTask
	| volunteer1 volunteer2 task |
	volunteer1 := Volunteer new.
	volunteer1 volunteerId: 1.
	volunteer2 := Volunteer new.
	volunteer2 volunteerId: 2.
	task := Task new.
	task applicantsAccepted: Dictionary new.
	task addApplicantAccepted: volunteer1.
	task addApplicantAccepted: volunteer2.
	task rejectVolunteer: volunteer1 volunteerId.
	self assert: task applicantsAccepted size = 1! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testRemoveSkillToTask
	| skill task |
	skill := Skill new.
	skill skillId: 1.
	skill name: 'Skill test'.
	task := Task new.
	task taskId: 1.
	task name: 'Task 1'.
	task skills: Dictionary new.
	task addSkill: skill.
	task removeSkill: skill skillId.
	self assert: task skills size = 0! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testSuggestVolunteerToTask
	| task1 isTrue skillsTask skillTask1 skillTask2 skillTask3 volunteer1 volunteer2 skillsVolunteer |
	skillTask1 := Skill new.
	skillTask1 skillId: 1.
	skillTask1 name: 'Smalltalk'.
	skillTask1 description: 'Intermediate Smalltalk'.
	skillTask2 := Skill new.
	skillTask2 skillId: 2.
	skillTask2 name: 'SUnit'.
	skillTask2 description: 'Advanced SUnit'.
	skillTask3 := Skill new.
	skillTask3 skillId: 3.
	skillTask3 name: 'Java'.
	skillTask3 description: 'Advanced Java'.
	volunteer1 := Volunteer new.
	volunteer1 volunteerId: 1.
	volunteer1 name: 'Erika Guetti Suca'.
	volunteer1 password: '123123'.
	volunteer1 email: 'eguetti18@gmail.com'.
	skillsVolunteer := Dictionary new.
	skillsVolunteer add: skillTask1 skillId -> skillTask1.
	volunteer1 skills: skillsVolunteer.
	volunteer2 := Volunteer new.
	volunteer2 volunteerId: 2.
	volunteer2 name: 'Evelyn Cervantes'.
	volunteer2 password: '123444'.
	volunteer2 email: 'evelyn@gmail.com'.
	skillsVolunteer := Dictionary new.
	skillsVolunteer add: skillTask2 skillId -> skillTask2.
	volunteer2 skills: skillsVolunteer.
	task1 := Task new.
	task1 taskId: 1.
	task1 name: 'Task Test'.
	task1 description: 'Description Test'.
	skillsTask := Dictionary new.
	skillsTask add: skillTask1 skillId -> skillTask1.
	skillsTask add: skillTask3 skillId -> skillTask3.
	task1 skills: skillsTask.
	task1 addVolunteer: volunteer1.
	task1 addVolunteer: volunteer2.
	task1 suggestVolunteers.
	isTrue := task1 applicantsAccepted includes: volunteer1.
	self assert: isTrue! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testaddSkillToTask
	| skill task |
	skill := Skill new.
	skill skillId: 1.
	skill name: 'Skill test'.
	task := Task new.
	task taskId: 1.
	task name: 'Task 1'.
	task skills: Dictionary new.
	task addSkill: skill.
	self assert: task skills size = 1! !

Object subclass: #Business
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

Business subclass: #ProjectVolunteer
	instanceVariableNames: 'projectId name status tasks coordinators'
	classVariableNames: 'ProjectDatabase'
	poolDictionaries: ''
	category: 'VMP'!

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
createProject: aProject 
	Transcript cr.
	Transcript show: '** creating a new Project'.
	Transcript cr.
	self projects add: aProject projectId -> aProject! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of projects'.
	Transcript cr.
	ProjectDatabase := Dictionary new add: 1
					-> (self
							projectId: 1
							name: 'Project 1'
							status: 'A');
				 add: 2
					-> (self
							projectId: 2
							name: 'Project 2'
							status: 'A');
				 add: 3
					-> (self
							projectId: 3
							name: 'Project 3'
							status: 'A');
				 yourself! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
deleteProject: aProjectId 
	| last |
	Transcript cr.
	Transcript show: '** disabling project'.
	Transcript cr.
	last := self projects at: aProjectId.
	last status: 'disable'.
	self projects add: aProjectId -> last! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
getProject: anInteger 
	^ self projects at: anInteger! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
getProjectVolunteer: anInteger 
	^ self projects at: anInteger! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
insertProject: aProject 
	Transcript cr.
	Transcript show: '** creating a new Project'.
	Transcript cr.
	self projects add: aProject projectId -> aProject! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
projectId: idInteger name: nameString status: statusString 
	^ self new projectId: idInteger;
		 name: nameString;
		 status: statusString;
		 tasks: Dictionary new;
		 coordinators: Dictionary new;
		 yourself! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
projects
	ProjectDatabase isNil
		ifTrue: [self createSampleDatabase].
	^ ProjectDatabase! !

!ProjectVolunteer class methodsFor: 'as yet unclassified' stamp: ''!
updateProject: aProject 
	Transcript cr.
	Transcript show: '** update a new Project'.
	Transcript cr.
	self projects add: aProject projectId -> aProject! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
addCoordinatorToProject: aCoordinator 
	self coordinators add: aCoordinator volunteerId -> aCoordinator! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
addTaskToProject: aTask 
	self listOfTask add: aTask! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
coordinators
	^ coordinators! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
coordinators: aListOfCoordinators 
	coordinators := aListOfCoordinators! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
name: aName 
	name := aName! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
projectId
	^ projectId! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
projectId: anInteger 
	projectId := anInteger! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
removeCoordinator
	^ self! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
status
	^ status! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
status: aStatus 
	status := aStatus! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
tasks
	^ tasks! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
tasks: aListOfTask 
	tasks := aListOfTask! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
updateSatus
	^ self! !

Business subclass: #ProjectVolunteerManager
	instanceVariableNames: 'projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
createProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
queryProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
removeProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
validateVolunteer
	^ self! !

Business subclass: #Skill
	instanceVariableNames: 'skillId name description creatorId'
	classVariableNames: 'SkillDataBase'
	poolDictionaries: ''
	category: 'VMP'!

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of skils'.
	Transcript cr.
	SkillDataBase := Dictionary new add: 1
					-> (self
							skillId: 1
							name: 'smallTalk language knowledge'
							description: '');
				 add: 2
					-> (self
							skillId: 2
							name: 'SUnit knowledge'
							description: '');
				 yourself! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
getSkill: aKey 
	^ self skills at: aKey! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
insertSkill: anSkill 
	Transcript cr.
	Transcript show: '** creating a new skill'.
	Transcript cr.
	self skills add: anSkill skillId -> anSkill! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
removeSkill: aKey 
	self skills removeKey: aKey! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
skillId: t1 name: t2 description: t3 
	^ self new skillId: t1;
		 name: t2;
		 description: t3;
		 yourself! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
skills
	SkillDataBase isNil
		ifTrue: [self createSampleDatabase].
	^ SkillDataBase! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
creatorId
	^ creatorId! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
creatorId: anVolunteerId 
	creatorId := anVolunteerId! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
description: t1 
	description := t1! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
skillId
	^ skillId! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
skillId: t1 
	skillId := t1! !

Business subclass: #Task
	instanceVariableNames: 'taskId creatorId name description status hours startDate completionDate deadline skills volunteers dependencies applicantsAccepted'
	classVariableNames: 'Database SkillDataBase'
	poolDictionaries: ''
	category: 'VMP'!

!Task class methodsFor: 'as yet unclassified' stamp: ''!
addTask: newTask 
	self tasks add: newTask taskId -> newTask! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of task'.
	Transcript cr.
	Database := Dictionary new add: 1 -> (self
						taskId: 1
						name: 'Smalltalk 1'
						description: 'Description 1'
						skills: Dictionary new
						add: 1
								-> (self
										skillId: 1
										name: 'SmallTalk'
										description: 'SmallTalk');
						 add: 2
							-> (self
									skillId: 2
									name: 'SUnit'
									description: 'SUnit'));
				 add: 2 -> (self
						taskId: 2
						name: 'J2EE'
						description: 'J2EE'
						skills: Dictionary new
						add: 3
								-> (self
										skillId: 3
										name: 'Java'
										description: 'Java');
						 add: 4
							-> (self
									skillId: 4
									name: 'Hibernate'
									description: 'Hibernate'));
				 add: 3 -> (self
						taskId: 3
						name: 'Game Programming C++'
						description: 'Description Game Programming'
						skills: Dictionary new
						add: 5
								-> (self
										skillId: 5
										name: 'C++'
										description: 'C++');
						 add: 6
							-> (self
									skillId: 6
									name: 'Visual C++'
									description: 'Visual C++'));
				 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabaseWithSkills
	Transcript cr.
	Transcript show: '* creating database of task'.
	Transcript cr.
	Database := Dictionary new add: 1 -> (self
						taskId: 1
						name: 'Smalltalk 1'
						description: 'Description 1'
						skills: Dictionary new
						add: 1
								-> (self
										skillId: 1
										name: 'SmallTalk'
										description: 'SmallTalk');
						 add: 2
							-> (self
									skillId: 2
									name: 'SUnit'
									description: 'SUnit'));
				 add: 2 -> (self
						taskId: 2
						name: 'J2EE'
						description: 'J2EE'
						skills: Dictionary new
						add: 3
								-> (self
										skillId: 3
										name: 'Java'
										description: 'Java');
						 add: 4
							-> (self
									skillId: 4
									name: 'Hibernate'
									description: 'Hibernate'));
				 add: 3 -> (self
						taskId: 3
						name: 'Game Programming C++'
						description: 'Description Game Programming'
						skills: Dictionary new
						add: 5
								-> (self
										skillId: 5
										name: 'C++'
										description: 'C++');
						 add: 6
							-> (self
									skillId: 6
									name: 'Visual C++'
									description: 'Visual C++'));
				 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 21:24'!
taskId: idInteger name: nameString description: descriptionString 
	^ self new taskId: idInteger;
		 name: nameString;
		 description: descriptionString;
		 applicantsAccepted: Dictionary new;
		 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 21:24'!
taskId: idInteger name: nameString description: descriptionString skills: skillsDictionary 
	^ self new taskId: idInteger;
		 name: nameString;
		 description: descriptionString;
		 skills: skillsDictionary;
		 applicantsAccepted: Dictionary new;
		 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 21:24'!
taskId: idInteger name: nameString description: descriptionString skills: skillsDictionary volunteers: volunteersDictionary 
	^ self new taskId: idInteger;
		 name: nameString;
		 description: descriptionString;
		 skills: skillsDictionary;
		 applicantsAccepted: Dictionary new;
		 volunteers: volunteersDictionary;
		 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
tasks
	Database isNil
		ifTrue: [self createSampleDatabase].
	^ Database! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
acceptVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
acceptVolunteer: aVolunteer 
	volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addApplicantAccepted: aVolunteer 
	applicantsAccepted add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addDependency: aTask 
	dependencies add: aTask taskId -> aTask! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addSkill: aSkill 
	skills add: aSkill skillId -> aSkill! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addSkill: key and: aSkill 
	skills add: key -> aSkill! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addVolunteer: aVolunteer 
	volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
applicantsAccepted
	^ applicantsAccepted! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
applicantsAccepted: newApplicantsAccepted 
	applicantsAccepted := newApplicantsAccepted! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
completionDate
	^ completionDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
completionDate: newCompletionDate 
	completionDate := newCompletionDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
creatorId
	^ creatorId! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
creatorId: newCreatorId 
	creatorId := newCreatorId! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
deadline
	^ deadline! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
deadline: newDeadLine 
	deadline := newDeadLine! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
dependencies
	^ dependencies! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
dependencies: newDependencies 
	dependencies := newDependencies! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
description: newDescription 
	description := newDescription! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
getSizeSkills
	^ skills size! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
hours
	^ hours! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
hours: newHours 
	hours := newHours! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
initialize
	skills := Dictionary new.
	dependencies := Dictionary new.
	volunteers := Dictionary new.
	applicantsAccepted := Dictionary new! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
name: newName 
	name := newName! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
rejectVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
rejectVolunteer: idVolunteer 
	applicantsAccepted removeKey: idVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
removeSkill: skillId 
	skills removeKey: skillId! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
removeVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
removeVolunteer: idVolunteer 
	volunteers removeKey: idVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
skills
	^ skills! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
skills: newSkills 
	skills := newSkills! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
start
	startDate := Date now! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
startDate
	^ startDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
startDate: newStartDate 
	startDate := newStartDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
status
	^ status! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
status: newStatus 
	status := newStatus! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
suggestVolunteers
	| hasSkill |
	applicantsAccepted := Dictionary new.
	self skills
		valuesDo: [:skill | volunteers
				valuesDo: [:volun | 
					hasSkill := volun skills includes: skill.
					hasSkill = true
						ifTrue: [applicantsAccepted add: volun volunteerId -> volun]]].
	^ applicantsAccepted! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
taskId
	^ taskId! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
taskId: Id 
	taskId := Id! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
terminate
	completionDate = Date new! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
volunteers
	^ volunteers! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
volunteers: newVolunteers 
	volunteers := newVolunteers! !

Business subclass: #TaskManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
createTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
queryTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
removeTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
suggestVolunteerTask
	^ self! !

Business subclass: #Volunteer
	instanceVariableNames: 'volunteerId name password status age gender skills email currentTasks creatorId isCoordinator coordinator'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'VMP'!

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
addSkillToVolunteer: anSkill 
	self skills add: anSkill! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 22:14'!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of volunteers firstTime'.
	Transcript cr.
	Database := Dictionary new add: 1
					-> (self
							volunteerId: 1
							name: 'Evelyn Perez Cervantes'
							password: '123123'
							creatorId: 1);
				 add: 2
					-> (self
							volunteerId: 2
							name: 'Nataly Perez Cervantes'
							password: '123123'
							creatorId: 1);
				 add: 3
					-> (self
							volunteerId: 3
							name: 'Sidney Perez Cervantes'
							password: '123123'
							creatorId: 1);
				 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
deleteVolunteer: aVolunteerId 
	| last |
	Transcript cr.
	Transcript show: '** disabling user'.
	Transcript cr.
	last := self volunteers at: aVolunteerId.
	last status: 'disable'.
	self volunteers add: aVolunteerId -> last! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
deleteVolunteer: aVolunteerId idCoordinator: anId 
	| last |
	Transcript cr.
	Transcript show: '** disabling user'.
	Transcript cr.
	last := self volunteers at: aVolunteerId.
	last creatorId == anId
		ifTrue: [last status: 'disable'].
	self volunteers add: aVolunteerId -> last! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
getVolunteer: anInteger 
	^ self volunteers at: anInteger! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
insertCoodinator: aCoordinator idCreator: anId 
	| us aVolunteer |
	Transcript cr.
	Transcript show: '** creating a new volunteer'.
	Transcript cr.
	us := self getVolunteer: anId.
	us coordinator == 1
		ifTrue: [self volunteers add: aVolunteer volunteerId -> aVolunteer]! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
insertVolunteer: aVolunteer 
	Transcript cr.
	Transcript show: '** creating a new volunteer'.
	Transcript cr.
	self volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
insertVolunteer: aVolunteer idCoordinator: anId 
	| us |
	Transcript cr.
	Transcript show: '** creating a new volunteer'.
	Transcript cr.
	us := self getVolunteer: anId.
	us coordinator == 1
		ifTrue: [self volunteers add: aVolunteer volunteerId -> aVolunteer]! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
listOfVolunteers
	| t1 |
	1
		to: self volunteers size
		do: [:t2 | 
			t1 := t1 + t2.
			Transcript show: self volunteers at: t2]! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:53'!
listOfVolunteers: aNumber status:anStatus
	Database isNil
		ifTrue: [self createSampleDatabase].
^ Database! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
name: t2 email: t3 
	^ self new name: t2;
		 email: t3;
		 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 21:44'!
showVolunteers
	Transcript
		show: 'ID        NAME      ';
		cr.
	Volunteer volunteers
		do: [ :volunteer | 
			Transcript show: volunteer volunteerId.
			Transcript show: '  '.
			Transcript
				show: volunteer name;
				cr ]! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
updateVolunteer: aVolunteer 
	Transcript cr.
	Transcript show: '** updating a new volunteer'.
	Transcript cr.
	Transcript show: aVolunteer skills size;
		 cr.
	self volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: 'Evelyn 10/22/2012 22:13'!
volunteerId: idInteger name: nameString password: aPassword creatorId: anCreatorId
	^ self new volunteerId: idInteger;
		 name: nameString;
		 password: aPassword;
		 skills: Dictionary new;
		 currentTasks: Dictionary new;
		 status: 'enable';
		 creatorId: anCreatorId;
		 coordinator: 0;
		 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
volunteers
	Database isNil
		ifTrue: [self createSampleDatabase].
	^ Database! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
addSkillToVolunteer: anSkill 
	self skills add: anSkill skillId -> anSkill! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
age
	^ age! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
age: t1 
	name := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
coordinator
	^ coordinator! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
coordinator: anInteger 
	coordinator := anInteger! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
creatorId
	^ creatorId! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
creatorId: anVolunteerId 
	creatorId := anVolunteerId! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
currentTasks
	^ currentTasks! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
currentTasks: aListOfTasks 
	currentTasks := aListOfTasks! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
email
	^ email! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
email: t1 
	email := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
gender
	^ gender! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
gender: t1 
	gender := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
hasSkill: skillId 
	^ self! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
isCoordinator
	^ isCoordinator! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
isCoordinator: aBoolean 
	isCoordinator := aBoolean! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
password
	^ password! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
password: aPassword 
	password := aPassword! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
removeSkillOfVolunteer: anInteger 
	self skills removeKey: anInteger! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
skills
	^ skills! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
skills: t1 
	skills := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
status
	^ status! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
status: aStatus 
	status := aStatus! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
volunteerId
	^ volunteerId! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
volunteerId: t1 
	volunteerId := t1! !

Object subclass: #Contact2
	instanceVariableNames: 'birthdate name emailAddress gender requestsEmailUpdates'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'VMP'!

!Contact2 class methodsFor: 'initialization' stamp: 'eve 11/5/2012 18:35'!
addContact: aContact
    self contacts add: aContact! !

!Contact2 class methodsFor: 'initialization' stamp: 'eve 11/5/2012 18:35'!
contacts
    "Answers an OrderedCollection of the contact information instances."

    Database isNil ifTrue: [ self createSampleDatabase ].
    ^ Database! !

!Contact2 class methodsFor: 'initialization' stamp: 'eve 11/5/2012 18:35'!
createSampleDatabase
    Database := OrderedCollection new
        add: (self name: 'Evelyn Perez Cervantes' emailAddress: 'epcervantes7@gmail.com');
        add: (self name: 'Nataly Perez Cervantes' emailAddress: 'natalypc2@gmail.com');
        add: (self name: 'Sidney Perez Cervantes' emailAddress: 'sidneypc27@gmail.com');
        yourself! !

!Contact2 class methodsFor: 'initialization' stamp: 'eve 11/5/2012 18:35'!
name: nameString emailAddress: emailString
    ^ self new
          name: nameString;
          emailAddress: emailString;
          yourself! !

!Contact2 class methodsFor: 'initialization' stamp: 'eve 11/5/2012 18:35'!
removeContact: aContact
    self contacts remove: aContact! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
beFemale
    gender := #Female! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
beMale
    gender := #Male! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
birthdate
	    ^ birthdate! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
birthdate:  aDate
    birthdate := aDate! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
emailAddress
    ^ emailAddress! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
emailAddress: aString
    emailAddress := aString! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
gender
    ^ gender ifNil: [ gender := #Male ]! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
isFemale
    ^ self gender = #Female! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
isMale
    ^ self gender = #Male! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
name
    ^ name! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
name: aString
    name := aString! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
requestsEmailUpdates
    ^ requestsEmailUpdates ifNil: [ requestsEmailUpdates := false ]! !

!Contact2 methodsFor: 'as yet unclassified' stamp: 'eve 11/5/2012 18:35'!
requestsEmailUpdates: aBoolean
    requestsEmailUpdates := aBoolean! !

Object subclass: #NameOfSubclass
	instanceVariableNames: ''
	classVariableNames: 'dataBaseConnection'
	poolDictionaries: ''
	category: 'VMP'!

Object subclass: #VMP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

Object subclass: #View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!
